#include "llmod.as"
#include "obj.as"
#include "progbox.as"

#module

#deffunc mtime val
	mref time,16
	ll_libload KERNEL,"kernel32"
	ll_getproc function,"GetTickCount",KERNEL
	ll_callfnv function
	ll_ret time
	ll_libfree KERNEL
return

#global

#define cp_end_wav "cp_end.wav"
#define cp_end_wav_track 0
#define win_x 320	;EBhE̕
#define win_y 240	;EBhE̍
#define tmp_dir_name "cp_tmp"


*init
	sdim message,1024 : message = "Xe[^X-ok\n"
	id_main_screen = 0
	screen id_main_screen,win_x,win_y,0,dispx-win_x/2,dispy-win_y/2
	title "]ʃRs["
	sndload cp_end_wav,cp_end_wav_track,0
	src_file = ""

	objsize 320,24 : input src_file,320,24 : id_inp_src = stat
	objsize 200,24 : button "]ʃRs[t@CI",*file_dialog : id_btn_fsel = stat
	objsize 120,24 : mes "]ʃRs["
	combox cp_amount, , "1\n2\n3\n4\n5\n" : id_cmb_amnt = stat
	cb_x = csrx : cb_y = csry
	pos cb_x+120+1, cb_y-24 : combox cp_unit,,"()\n(x10,000)" : id_cmb_unit = stat
	pos 0, : button "]ʃRs[s", *exec_cp : id_btn_cp_exec = stat

	cb_x = csrx : cb_y = csry
	pos cb_x+120+1, cb_y-24 : objsize 320,24 : font "", 12, : objmode 2,  :chkbox "]ʃRs[Iɉ炷",flag_cp_end_wav : objmode 0,
	pos 0, : objsize 120,24: button "Zbg", *reset_dsp : id_btn_reset = stat

	button "I", *goto_end: id_btn_end = stat

	mesbox message, 320, 24, 2: id_mesbox = stat

	progbox 320,50 : id_pbar = stat :progset 255<<8,3

	objsel id_inp_src

	stop



*goto_end
	end

*file_dialog
	dialog "*",16,"Rs[t@C"
	//t@CA擾
	if stat=1 {
		src_file = refstr
		objprm 0, src_file
		gosub make_dst_name
	}
	stop

*exec_cp
	gosub *chk_file
	file_num = 0
	cp_time = (cp_amount + 1) * 1000 * 60
	tmp_dir = dst_file_path +"\\" + tmp_dir_name
	objprm id_mesbox, "Rs[:" + tmp_dir  + "\n"
	gosub *chk_dir : if exist_dir < 1 : mkdir tmp_dir
	objprm id_mesbox, "fBNg-ok" + "\n" 
	gosub *obj_disable
	objprm id_mesbox, "]ʃRs[łB~͏I{^"  + "\n"
	if cp_unit == 0 : gosub *cp_by_time : else : gosub *cp_by_num
	if flag_cp_end_wav > 0 :snd cp_end_wav_track
	objprm id_mesbox,"]ʃRs[܂"
	gosub *obj_able
	stop

*cp_by_time
	file_num = 0
	mtime time_start	;
	time_end = time_start + cp_time
	repeat 
		mtime time_current
		if time_current >= time_end : break
		bcopy src_file, tmp_dir + "\\" + dst_file_base + file_num + dst_file_ext
		file_num++
		progset
		wait 1
	loop
	return
*cp_by_num
	count = 0
	num_end = (cp_amount+1) * 10000
	for count, 0, num_end, 1
		bcopy src_file, tmp_dir + "\\" + dst_file_base + count + dst_file_ext
		progset
		wait 1
	next
	return
*chk_file
	if src_file == "" {
		error_msg = "t@CIĂ"
		goto *error_stop
	} else {
	 	exist src_file
		if strsize <=0 {
			error_msg = "t@C󂩁A݂܂"
			goto *error_stop
		}
	}
	return

*chk_dir
	dirlist exist_dir_list, tmp_dir,5
	exist_dir = stat
	return

*obj_disable
	objgray id_cmb_amnt,0
	objgray id_cmb_unit,0
	objgray id_inp_src,0
	objgray id_btn_fsel,0
	objgray id_btn_cp_exec,0
	objgray id_btn_reset,0
	progset 0, 1
	return
*obj_able
	objgray id_cmb_amnt,1
	objgray id_cmb_unit,1
	objgray id_inp_src,1
	objgray id_btn_fsel,1
	objgray id_btn_cp_exec,1
	objgray id_btn_reset,1
	progset 100, 1
	objsel id_inp_src
	return

*reset_dsp
	objprm id_inp_src, "" : src_file = ""
	objprm id_cmb_amnt,0 : cp_amount = 0
	objprm id_cmb_unit,0  : cp_unit = 0
	objprm id_mesbox, "Xe[^X-ok" + "\n"
	progset 0, 1
	objsel id_inp_src
	stop

*make_dst_name
	getpath dst_file_base, src_file, 8+1
	getpath dst_file_ext, src_file, 8+2
	getpath dst_file_path, src_file, 32
	return

*error_stop
	dialog error_msg,1,"G["
	stop


